//###########################################################################
//# ftpbnc 0.4 by comrade
//# comrade2k@hotmail.com
//# http://comrade64.cjb.net/
//###########################################################################
//###########################################################################
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <openssl/rand.h>
#include <openssl/md5.h>
#include "lib_mdidentd.h"
//###########################################################################
typedef struct {
	int lsock, rsock;
	unsigned long int locals, remotes, localb, remoteb;
	char *local, *remote, *remoteall;
	unsigned char status; unsigned char flags;
	SSL *lssl, *rssl;
} CONN; // 42 bytes
//###########################################################################
#define max(a, b)  ((a) > (b) ? (a) : (b))
#define min(a, b)  ((a) < (b) ? (a) : (b))
#define chkflag(x, flag) ((x & flag) == flag)
#define BUFFER_SIZE 4096
#define MAX_SOCKETS 128
#define LOG_LEVEL 0
// state constants
#define STATE_USERNAME		0x00
#define STATE_PASSWORD		0x01
#define STATE_CONNECT		0x02
#define STATE_CONNECTED 	0x03
#define STATE_NEGOTIATE 	0x04
#define STATE_ESTABLISHED	0xFF
// flag constants
#define FLAG_HOLDREMOTE 	0x01
#define FLAG_RSECURE		0x02
#define FLAG_LSECURE		0x04
//###########################################################################
CONN conns[MAX_SOCKETS];
int lsock, csock, rsock, sockets=0;
char *welcome	= "220 [ftpbnc 0.4 by comrade] ready\x0D\x0A";
char *passwdreq = "331 Password required.\x0D\x0A";
char *loggedin	= "230 User logged in.\x0D\x0A";
char *loginbad	= "530 Login incorrect.\x0D\x0A";
//char *badcmd	  = "530 Bad command.\x0D\x0A";
//###########################################################################
int main(int, char**);
void log(unsigned int, const char*, ...);
void remove_conn(unsigned int);
void freeres();
void bin2hex(void *data, unsigned long int length, unsigned char *s);
void hex2bin(void *data, unsigned long int length, unsigned char *s);
void quit(const char*);
void sigterm(int);
//###########################################################################
//###########################################################################
//###########################################################################
//###########################################################################
int main(int argc, char **argv){
	FILE* hFile; unsigned char pid[16], line[256]; unsigned int i, k;
	struct sockaddr_in lsin, sin; struct hostent *hp; fd_set fds; struct timeval tv;
	signed int bytes; SSL_CTX *ctx; //STACK_OF(SSL_CIPHER) *ciphers;
	unsigned char *rhost, *rport, *rident, lhost[256], username[32], password[16], rpass[16], localssl; unsigned short int lport;

	log(0, "  ftpbnc 0.4 by comrade\n  comrade2k@hotmail.com\n  http://comrade64.cjb.net/");

	memset(&lhost, 0, sizeof(lhost));
	memset(&username, 0, sizeof(username));
	memset(&password, 0, sizeof(password));
	localssl = 0;
	lport = 0;
	if (argc==2) {		// read settings from configuration file
		if (!(hFile = fopen(argv[1], "r"))) quit("Failed to open configuration file!");
		while(fgets(line, sizeof(line), hFile)){
			if (line[strlen(line)-1] == '\n') line[strlen(line)-1] = 0;
			if ((line[0]=='#') || (line[0]==';')) continue;
			if (!strncasecmp(line, "lhost=", 6)) strncpy(lhost, line+6, sizeof(lhost)-1);
			else if (!strncasecmp(line, "lport=", 6)) lport = atoi(line+6);
			else if (!strncasecmp(line, "localssl=", 9)) localssl = atoi(line+9);
			else if (!strncasecmp(line, "username=", 9)) strncpy(username, line+9, sizeof(username)-1);
			else if (!strncasecmp(line, "password=", 9)) {
				if ((!strncasecmp(line+9, "MD5:", 4)) && (strlen(line+9)==36)) hex2bin(&password, 16, line+9+4);
				else (void)MD5(line+9, strlen(line+9), password);
			}
			memset(&line, 0, sizeof(line));
		}
		fclose(hFile);
	} else if (argc==5 || argc==6){	// all settings in command-line
		localssl=i=((strcasecmp(argv[1], "--ssl")) ? 0 : 1);
		lport = atoi(argv[2+i]);
		strncpy(lhost, argv[1+i], sizeof(lhost)-1);
		strncpy(username, argv[3+i], sizeof(username)-1);
		if ((!strncasecmp(argv[4+i], "MD5:", 4)) && (strlen(argv[4+i])==36)) hex2bin(&password, 16, argv[4+i]+4);
		else (void)MD5(argv[4+i], strlen(argv[4+i]), password);
	} else {
		log(0, "Usage: ftpbnc --ssl listenhost listenport username password");
		log(0, "       ftpbnc ftpbnc.conf");
		return 0;
	}
	log(1, "LHOST=%s", lhost);
	log(1, "LPORT=%u", lport);
	log(1, "USERNAME=%s", username);

	//signal(SIGHUP, SIG_IGN);
	signal(SIGTERM, sigterm);
	signal(SIGPIPE, SIG_IGN);
	if (fork()) return 0;	// parent

	memset(&conns, 0, sizeof(conns));

	if (!SSL_library_init()) quit("Failed to initialize SSL!");
	SSL_load_error_strings();
	if (!(ctx = SSL_CTX_new(SSLv23_method()))) quit("Failed to create SSL context!");
	SSL_CTX_use_certificate_file(ctx, "cert.pem" ,SSL_FILETYPE_PEM);
	SSL_CTX_use_RSAPrivateKey_file(ctx, "key.pem" ,SSL_FILETYPE_PEM);
	SSL_CTX_set_session_cache_mode(ctx, SSL_SESS_CACHE_BOTH);
	SSL_CTX_sess_set_cache_size(ctx, BUFFER_SIZE);

	hFile = fopen("ftpbnc.pid", "wb");
	fwrite(&pid, sprintf(pid, "%lu\n", getpid()), 1, hFile);
	fclose(hFile);
	log(0, "\nSuccessfully loaded into background (PID %lu)...", getpid());
	if ((lsock = socket(AF_INET, SOCK_STREAM, 0)) == -1) quit("Failed to create socket!");
	log(1, "lsock = %08X", lsock);
	//fcntl(lsock, F_SETFL, O_NONBLOCK);
	i = 1;
	if (setsockopt(lsock, SOL_SOCKET, SO_REUSEADDR, &i, sizeof(i))) quit("Failed to set socket options!");
	lsin.sin_family = AF_INET; lsin.sin_port = htons(lport);
	if ((lsin.sin_addr.s_addr = inet_addr(lhost)) == INADDR_NONE){
		if (!(hp = gethostbyname(lhost))) quit("Invalid listen hostname!");
		memcpy(&lsin.sin_addr, hp->h_addr, hp->h_length);
	}
	if (bind(lsock, (struct sockaddr*)&lsin, sizeof(lsin))) quit("Failed to bind socket!");
	if (listen(lsock, 5)) quit("Failed to listen on socket!");
	while(1){
		// accept new connections
		FD_ZERO(&fds);
		FD_SET(lsock, &fds);
		tv.tv_sec = 0; tv.tv_usec = 250;
		if (select(lsock+1, &fds, 0, 0, &tv)){
			if (FD_ISSET(lsock, &fds)){
				csock = accept(lsock, 0, 0);
				log(1, "csock = %08X", csock);
				if ((csock) > 0){
					log(1, "New connection");
					memset(&conns[sockets], 0, sizeof(conns[sockets]));
					if (localssl){
						fcntl(csock, F_SETFL, 0);
						conns[sockets].lssl = SSL_new(ctx);
						SSL_set_fd(conns[sockets].lssl, csock);
						SSL_set_mode(conns[sockets].lssl, SSL_MODE_AUTO_RETRY);
						SSL_set_accept_state(conns[sockets].lssl);
						k = SSL_accept(conns[sockets].lssl);
						log(1, "SSL_accept() returned %u", k);
						if (k == 1) conns[sockets].flags |= FLAG_LSECURE;
					}
					fcntl(csock, F_SETFL, O_NONBLOCK);
					conns[sockets].lsock = csock;
					conns[sockets].rsock = 0;
					conns[sockets].local = malloc(BUFFER_SIZE);
					conns[sockets].remote = malloc(BUFFER_SIZE);
					if (chkflag(conns[sockets].flags, FLAG_LSECURE)) SSL_write(conns[sockets].lssl, welcome, strlen(welcome));
					else send(csock, welcome, strlen(welcome), 0);
					sockets++;
				}
			}
		}
		// bounce data
		for(i = 0; i < sockets; i++){
			// send buffered data
			if (((conns[i].localb && (conns[i].localb <= BUFFER_SIZE)) || (!chkflag(conns[i].flags, FLAG_HOLDREMOTE) && conns[i].remoteb && (conns[i].remoteb <= BUFFER_SIZE)))){
				if ((conns[i].localb <= BUFFER_SIZE) && conns[i].localb && conns[i].rsock){
					log(2, "Send to REMOTE: %s (%lu bytes)", conns[i].local+conns[i].locals, conns[i].localb-conns[i].locals);
					if (chkflag(conns[i].flags, FLAG_RSECURE)) bytes = SSL_write(conns[i].rssl, conns[i].local+conns[i].locals, conns[i].localb-conns[i].locals);
					else bytes = send(conns[i].rsock, conns[i].local+conns[i].locals, conns[i].localb-conns[i].locals, 0);

					log(2, "Sent %u bytes (secure=%u)!", bytes, chkflag(conns[i].flags, FLAG_RSECURE));
					if (bytes < 0) bytes = 0;
					if (bytes < (conns[i].localb-conns[i].locals)) conns[i].locals += bytes;
					else { conns[i].locals = 0; conns[i].localb = 0; }
				}
				if (!chkflag(conns[i].flags, FLAG_HOLDREMOTE) && (conns[i].remoteb <= BUFFER_SIZE) && conns[i].remoteb && conns[i].lsock){
					log(2, "Send to  LOCAL: %s (%lu bytes)", conns[i].remote+conns[i].remotes, conns[i].remoteb-conns[i].remotes);
					if (chkflag(conns[i].flags, FLAG_LSECURE)) bytes = SSL_write(conns[i].lssl, conns[i].remote+conns[i].remotes, conns[i].remoteb-conns[i].remotes);
					else bytes = send(conns[i].lsock, conns[i].remote+conns[i].remotes, conns[i].remoteb-conns[i].remotes, 0);
					if (bytes < 0) bytes = 0;
					log(2, "Sent %u bytes (secure=%u)!", bytes, chkflag(conns[i].flags, FLAG_LSECURE));
					if (bytes < (conns[i].remoteb-conns[i].remotes)) conns[i].remotes += bytes;
					else { conns[i].remotes = 0; conns[i].remoteb = 0; }
				}
				continue;
			}
			// receive new data
			memset(conns[i].local, 0, BUFFER_SIZE);
			memset(conns[i].remote, 0, BUFFER_SIZE);
			if (!chkflag(conns[i].flags, FLAG_LSECURE) && (conns[i].lsock) && !(conns[i].localb = recv(conns[i].lsock, conns[i].local, BUFFER_SIZE, 0))) {
				log(1, "Local socket died");
				remove_conn(i);
			} else if (chkflag(conns[i].flags, FLAG_LSECURE) && (conns[i].lsock) && !(conns[i].localb = SSL_read(conns[i].lssl, conns[i].local, BUFFER_SIZE))) {
				log(1, "Local socket died (secure)");
				remove_conn(i);
			} else if (!chkflag(conns[i].flags, FLAG_RSECURE) && (conns[i].rsock) && !(conns[i].remoteb = recv(conns[i].rsock, conns[i].remote, BUFFER_SIZE, 0))) {
				log(1, "Remote socket died");
				remove_conn(i);
			} else if (chkflag(conns[i].flags, FLAG_RSECURE) && (conns[i].rsock) && !(conns[i].remoteb = SSL_read(conns[i].rssl, conns[i].remote, BUFFER_SIZE))) {
				log(1, "Remote socket died (secure)");
				remove_conn(i);
			} else {
				if (( conns[i].localb <= BUFFER_SIZE) &&  conns[i].localb) log(1, "Got	local data (%u bytes): %s", conns[i].localb, conns[i].local);
				if ((conns[i].remoteb <= BUFFER_SIZE) && conns[i].remoteb) log(1, "Got remote data (%u bytes): %s", conns[i].remoteb, conns[i].remote);
				if ((conns[i].status!=STATE_ESTABLISHED) && conns[i].lsock && conns[i].localb && (conns[i].localb <= BUFFER_SIZE)){
					// not connected yet
					log(2, "Received: %s", conns[i].local);
					if ((conns[i].status==STATE_USERNAME) && (!strncasecmp(conns[i].local, "user", 4))){
						// check for username
						log(1, "Checking username...");
						conns[i].local[conns[i].localb-2] = 0;
						if (!strcmp(username, conns[i].local+5)){
							memcpy(conns[i].remote, passwdreq, strlen(passwdreq));
							conns[i].status++;	// STATE_PASSWORD
						} else memcpy(conns[i].remote, loginbad, strlen(loginbad));
						conns[i].remoteb = strlen(conns[i].remote);
						conns[i].localb = 0;
					} else if ((conns[i].status==STATE_PASSWORD) && (!strncasecmp(conns[i].local, "pass", 4))) {
						// check for password
						log(1, "Checking password...");
						conns[i].local[conns[i].localb-2] = 0;
						memset(&rpass, 0, sizeof(rpass));
						(void)MD5(conns[i].local+5, strlen(conns[i].local+5), rpass);
						if (!memcmp(&password, &rpass, sizeof(password))){
							memcpy(conns[i].remote, loggedin, strlen(loggedin));
							conns[i].status++;	// STATE_CONNECT
						} else {
							memcpy(conns[i].remote, loginbad, strlen(loginbad));
							conns[i].status--;	// STATE_USERNAME
						}
						conns[i].remoteb = strlen(conns[i].remote);
						conns[i].localb = 0;
					} else if ((conns[i].status==STATE_CONNECT) && ((!strncasecmp(conns[i].local, "open", 4)) || (!strncasecmp(conns[i].local, "site", 4)))) {
						// check for ident@host:port
						log(1, "Bouncing...");
						conns[i].local[conns[i].localb-2] = 0;
						rident = 0;
						if (!(rhost = strchr(&conns[i].local[5], '@'))) rhost = &conns[i].local[5]; else { *rhost++ = 0; rident = &conns[i].local[5]; }  
						if (!(rport = strchr(rhost, ':'))) rport = strchr(rhost, ' ');
						sin.sin_family = AF_INET;
						if (rport){
							*rport++=0;
							sin.sin_port = htons(atoi(rport));
						} else sin.sin_port = htons(21);
						log(1, "Connecting to %s:%u (ident %s)...", rhost, ntohs(sin.sin_port), rident);

						rsock = socket(AF_INET, SOCK_STREAM, 0);
						log(1, "rsock = %08X", rsock);
						fcntl(rsock, F_SETFL, O_NONBLOCK);
						lsin.sin_port = 0;
						bind(rsock, (struct sockaddr*)&lsin, sizeof(lsin));
						k = sizeof(lsin);
						getsockname(rsock, (struct sockaddr*)&lsin, &k);
						log(2, "remote socket listening on :%u", lsin.sin_port);
						if (rident && strlen(rident)) log(1, "register ident: %s", ident_error(register_fake_ident(MDIDENTD_PATH, rident, lsin.sin_port, ntohs(sin.sin_port))));
						if ((sin.sin_addr.s_addr = inet_addr(rhost)) == INADDR_NONE){
							if (!(hp = gethostbyname(rhost))) break;
							memcpy(&sin.sin_addr, hp->h_addr, hp->h_length);
						}
						if ((!connect(rsock, (struct sockaddr*)&sin, sizeof(sin))) || (errno==EINPROGRESS)){
							log(1, "Connected!");
							conns[i].rsock = rsock;
							conns[i].status++;				// STATE_CONNECTED
							conns[i].flags |= FLAG_HOLDREMOTE;		// don't echo negotiation to local
							conns[i].remoteall = malloc(BUFFER_SIZE);	// save negotiation data
							memset(conns[i].remoteall, 0, BUFFER_SIZE);
						} else remove_conn(i);
						conns[i].localb = 0; conns[i].remoteb = 0;
					} else {
						log(1, "Bad command");
						//memcpy(remote, &badcmd, sizeof(badcmd));
						//remoteb = strlen(remote);
						conns[i].localb = 0; conns[i].remoteb = 0;
						remove_conn(i);
					}
				} else if ((conns[i].status==STATE_CONNECTED) && conns[i].remoteb && (conns[i].remoteb <= BUFFER_SIZE)) {
					log(1, "FROM SERVER: %s", conns[i].remote);
					memcpy(conns[i].remoteall+strlen(conns[i].remoteall), conns[i].remote, conns[i].remoteb);
					if (conns[i].remote[3] != '-') {
						strcpy(conns[i].local, "AUTH TLS\x0D\x0A");
						conns[i].localb = strlen(conns[i].local);
						conns[i].status++;	// STATE_NEGOTIATE
					}
				} else if ((conns[i].status==STATE_NEGOTIATE) && conns[i].remoteb && (conns[i].remoteb <= BUFFER_SIZE)) {
					if (!memcmp(conns[i].remote, "234 ", 4)){
						log(1, "WANTS TO NEGOTIATE!");
						fcntl(conns[i].rsock, F_SETFL, 0);
						conns[i].rssl = SSL_new(ctx);
						//SSL_set_session_id_context(conns[i].rssl, "test", 4);
						SSL_set_fd(conns[i].rssl, conns[i].rsock);
						SSL_set_connect_state(conns[i].rssl);
						SSL_set_mode(conns[i].rssl, SSL_MODE_AUTO_RETRY);
						k = SSL_connect(conns[i].rssl);
						log(1, "SSL_connect() returned %u", k);
						/*ciphers = SSL_get_ciphers(conns[i].rssl);
						for(k=0; k < sk_num(ciphers); k++){
							log(1, "CIPHER: %s", SSL_CIPHER_get_name((SSL_CIPHER*)sk_value(ciphers, k)));
						}*/
						conns[i].flags = (conns[i].flags & ~FLAG_HOLDREMOTE) | FLAG_RSECURE;
						memcpy(conns[i].remote, conns[i].remoteall, strlen(conns[i].remoteall));
						conns[i].remoteb = strlen(conns[i].remoteall);
						free(conns[i].remoteall);
						fcntl(conns[i].rsock, F_SETFL, O_NONBLOCK);
						conns[i].status = STATE_ESTABLISHED;
						conns[i].localb = 0;
					} else {
						log(1, "NO TLS HERE");
						memcpy(conns[i].remote, conns[i].remoteall, strlen(conns[i].remoteall));
						conns[i].remoteb = strlen(conns[i].remoteall);
						free(conns[i].remoteall);
						conns[i].flags &= ~FLAG_HOLDREMOTE;
						conns[i].status = STATE_ESTABLISHED;
						conns[i].localb = 0;
					}
				}
			}
		}
	}
	SSL_CTX_free(ctx);
	return 0;
}
//###########################################################################
void log(unsigned int level, const char *format, ...){
	va_list args;
	if (level>LOG_LEVEL) return;
	va_start(args, format);
	vprintf(format, args);
	va_end(args);
	puts("");
	fflush(stdout);
	return;
}
//###########################################################################
void remove_conn(unsigned int index){
	log(1, "Removing connection %u\n=========================", index);
	//shutdown(conns[index].lsock, 2); shutdown(conns[index].rsock, 2);
	if (conns[index].lsock) close(conns[index].lsock);
	if (conns[index].rsock) close(conns[index].rsock);
	if (conns[index].local) free(conns[index].local);
	if (conns[index].remote) free(conns[index].remote);
	if (conns[index].lssl){
		SSL_set_shutdown(conns[index].lssl, SSL_SENT_SHUTDOWN | SSL_RECEIVED_SHUTDOWN);
		SSL_free(conns[index].lssl);
	}
	if (conns[index].rssl){
		SSL_set_shutdown(conns[index].rssl, SSL_SENT_SHUTDOWN | SSL_RECEIVED_SHUTDOWN);
		SSL_free(conns[index].rssl);
	}
	memcpy(&conns[index], &conns[index+1], (MAX_SOCKETS-index-1)*sizeof(CONN));
	sockets--;
}
//###########################################################################
void freeres(){
	int i=0;
	for(i; i < sockets; i++){
		//shutdown(conns[i].lsock, 2); shutdown(conns[i].rsock, 2);
		if (conns[i].lsock) close(conns[i].lsock);
		if (conns[i].rsock) close(conns[i].rsock);
		if (conns[i].local) free(conns[i].local);
		if (conns[i].remote) free(conns[i].remote);
		if (conns[i].lssl){
			SSL_set_shutdown(conns[i].lssl, SSL_SENT_SHUTDOWN | SSL_RECEIVED_SHUTDOWN);
			SSL_free(conns[i].lssl);
		}
		if (conns[i].rssl){
			SSL_set_shutdown(conns[i].rssl, SSL_SENT_SHUTDOWN | SSL_RECEIVED_SHUTDOWN);
			SSL_free(conns[i].rssl);
		}
	}
	close(rsock); close(csock); close(lsock);
}
//###########################################################################
void bin2hex(void *data, unsigned long int length, unsigned char *s){
	unsigned char c, o[2];
	memset(s, 0, length*2+1);
	while(length--){
		c = *(unsigned char*)data++;
		if (((c & 0x0F)) >= 0x0A) o[0] = (((c & 0x0F)) - 0x0A + 'A');
		else o[0] = (((c & 0x0F)) + '0');
		if (((c & 0xF0) >> 4) >= 0x0A) o[1] = (((c & 0xF0) >> 4) - 0x0A + 'A');
		else o[1] = (((c & 0xF0) >> 4) + '0');
		*s++ = o[1]; *s++ = o[0];
	}
}
//###########################################################################
void hex2bin(void *data, unsigned long int length, unsigned char *s){
	unsigned char c, i[2];
	memset(data, 0, length);
	while(length--){
		i[0] = *(unsigned char*)s++; i[1] = *(unsigned char*)s++;
		if (i[0] >= 'A') c = (i[0] - 'A') + 10;
		else c = (i[0] - '0');
		c <<= 4;
		if (i[1] >= 'A') c += (i[1] - 'A') + 10;
		else c += (i[1] - '0');
		*(unsigned char*)data++ = c;
	}
}
//###########################################################################
void quit(const char* error){ freeres(); log(0, "Quitting: %s", error); exit(0); }
//###########################################################################
void sigterm(int sig){ freeres(); exit(0); }
//###########################################################################
//###########################################################################
